Index: issm/branches/trunk-jpl-damage/src/c/Container/Observations.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Observations.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Observations.cpp	(revision 12878)
@@ -20,5 +20,7 @@
 #include "../shared/shared.h"
 #include "../include/include.h"
+#include "../modules/modules.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
+#include "../io/io.h"
 
 using namespace std;
@@ -32,12 +34,12 @@
 }
 /*}}}*/
-/*FUNCTION Observations::Observations(double* observations_list,double* x,double* y,int n,Options* options){{{*/
-Observations::Observations(double* observations_list,double* x,double* y,int n,Options* options){
+/*FUNCTION Observations::Observations(IssmDouble* observations_list,IssmDouble* x,IssmDouble* y,int n,Options* options){{{*/
+Observations::Observations(IssmDouble* observations_list,IssmDouble* x,IssmDouble* y,int n,Options* options){
 
 	/*Intermediaries*/
-	int          i,maxdepth,level,counter;
+	int          i,j,maxdepth,level,counter,index;
 	int          xi,yi;
-	double       xmin,xmax,ymin,ymax;
-	double       offset,minlength;
+	IssmDouble       xmin,xmax,ymin,ymax;
+	IssmDouble       offset,minlength,minspacing,mintrimming,maxtrimming;
 	Observation *observation = NULL;
 
@@ -52,17 +54,23 @@
 	offset=0.05*(ymax-ymin); ymin-=offset; ymax+=offset;
 
+	/*Get trimming limits*/
+	options->Get(&mintrimming,"mintrimming",-1.e+21);
+	options->Get(&maxtrimming,"maxtrimming",+1.e+21);
+	options->Get(&minspacing,"minspacing",0.01);
+	if(minspacing<=0) _error2_("minspacing must > 0");
+
 	/*Get Minimum box size*/
 	if(options->GetOption("boxlength")){
 		options->Get(&minlength,"boxlength");
-		if(minlength<=0)_error_("boxlength should be a positive number");
+		if(minlength<=0)_error2_("boxlength should be a positive number");
 		maxdepth=int(log(max(xmax-xmin,ymax-ymin)/minlength +1)/log(2.0));
 	}
 	else{
 		maxdepth = 30;
-		minlength=max(xmax-xmin,ymax-ymin)/double((1L<<maxdepth)-1);
+		minlength=max(xmax-xmin,ymax-ymin)/IssmDouble((1L<<maxdepth)-1);
 	}
 
 	/*Initialize Quadtree*/
-	printf("Generating quadtree with a maximum box size %g (depth=%i)... ",minlength,maxdepth);
+	_pprintString_("Generating quadtree with a maximum box size " << minlength << " (depth=" << maxdepth << ")... ");
 	this->quadtree = new Quadtree(xmin,xmax,ymin,ymax,maxdepth);
 
@@ -70,4 +78,16 @@
 	counter = 0;
 	for(i=0;i<n;i++){
+
+		/*First check limits*/
+		if(observations_list[i]>maxtrimming) continue;
+		if(observations_list[i]<mintrimming) continue;
+
+		/*First check that this observation is not too close from another one*/
+		this->quadtree->ClosestObs(&index,x[i],y[i]);
+		if(index>=0){
+			observation=(Observation*)this->GetObjectByOffset(index);
+			if(pow(observation->x-x[i],2)+pow(observation->y-y[i],2) < minspacing) continue;
+		}
+
 		this->quadtree->IntergerCoordinates(&xi,&yi,x[i],y[i]);
 		this->quadtree->QuadtreeDepth2(&level,xi,yi);
@@ -82,5 +102,7 @@
 		}
 	}
-	printf("done\n");
+	_pprintLine_("done");
+	_pprintLine_("Initial number of observations: " << n);
+	_pprintLine_("  Final number of observations: " << this->quadtree->NbObs);
 }
 /*}}}*/
@@ -93,35 +115,121 @@
 
 /*Methods*/
-/*FUNCTION Observations::ObservationList{{{*/
-void Observations::ObservationList(double **px,double **py,double **pobs,int* pnobs,double x_interp,double y_interp,double range){
+/*FUNCTION Observations::ClosestObservation{{{*/
+void Observations::ClosestObservation(IssmDouble *px,IssmDouble *py,IssmDouble *pobs,IssmDouble x_interp,IssmDouble y_interp,IssmDouble radius){
 
 	/*Output and Intermediaries*/
+	bool         stop;
 	int          nobs,i,index;
-	double      *x            = NULL;
-	double      *y            = NULL;
-	double      *obs          = NULL;
+	IssmDouble       h2,hmin2,radius2;
+	int         *indices      = NULL;
 	Observation *observation  = NULL;
+
+	/*If radius is not provided or is 0, return all observations*/
+	if(radius==0) radius=this->quadtree->root->length;
+
+	/*Compute radius square*/
+	radius2 = radius*radius;
+
+	/*Find all observations that are in radius*/
+	this->quadtree->RangeSearch(&indices,&nobs,x_interp,y_interp,radius);
+	for (i=0;i<nobs;i++){
+		observation=(Observation*)this->GetObjectByOffset(indices[i]);
+		h2 = (observation->x-x_interp)*(observation->x-x_interp) + (observation->y-y_interp)*(observation->y-y_interp);
+
+		if(i==0){
+			hmin2 = h2;
+			index = i;
+		}
+		else{
+			if(h2<hmin2){
+				hmin2 = h2;
+				index = i;
+			}
+		}
+	}  
+
+	/*Assign output pointer*/
+	if(!nobs){
+		*px=UNDEF;
+		*py=UNDEF;
+		*pobs=UNDEF;
+	}
+	else{
+		observation=(Observation*)this->GetObjectByOffset(indices[index]);
+		*px=observation->x;
+		*py=observation->y;
+		*pobs=observation->value;
+	}
+	xDelete<int>(indices);
+
+}/*}}}*/
+/*FUNCTION Observations::ObservationList(IssmDouble **px,IssmDouble **py,IssmDouble **pobs,int* pnobs,IssmDouble x_interp,IssmDouble y_interp,IssmDouble radius,int maxdata){{{*/
+void Observations::ObservationList(IssmDouble **px,IssmDouble **py,IssmDouble **pobs,int* pnobs,IssmDouble x_interp,IssmDouble y_interp,IssmDouble radius,int maxdata){
+
+	/*Output and Intermediaries*/
+	bool         stop;
+	int          nobs,tempnobs,i,j,k,n,counter;
+	IssmDouble       h2,radius2;
 	int         *indices      = NULL;
-
-	/*Treat range*/
-	if(range==0){
-		range=this->quadtree->root->length;
-	}
-
-	/*Find all observations that are in range*/
-	this->quadtree->RangeSearch(&indices,&nobs,x_interp,y_interp,range);
-
-	if(nobs==0){
-		/*No observation found, double range*/
-		//printf("No observation found within range, doubling range\n");
-		xfree((void**)&indices);
-		this->ObservationList(&x,&y,&obs,&nobs,x_interp,y_interp,range*2);
-	}
-	else{
-		//if(nobs>1000) printf("Taking more than 1000 observations\n");
+	int         *tempindices  = NULL;
+	IssmDouble      *dists        = NULL;
+	IssmDouble      *x            = NULL;
+	IssmDouble      *y            = NULL;
+	IssmDouble      *obs          = NULL;
+	Observation *observation  = NULL;
+
+	/*If radius is not provided or is 0, return all observations*/
+	if(radius==0) radius=this->quadtree->root->length;
+
+	/*Compute radius square*/
+	radius2 = radius*radius;
+
+	/*Find all observations that are in radius*/
+	this->quadtree->RangeSearch(&tempindices,&tempnobs,x_interp,y_interp,radius);
+	if(tempnobs){
+		indices = xNew<int>(tempnobs);
+		dists   = xNew<IssmDouble>(tempnobs);
+	}
+	nobs = 0;
+	for (i=0;i<tempnobs;i++){
+		observation=(Observation*)this->GetObjectByOffset(tempindices[i]);
+		h2 = (observation->x-x_interp)*(observation->x-x_interp) + (observation->y-y_interp)*(observation->y-y_interp);
+
+		if(nobs==maxdata && h2>radius2) continue;
+		if(nobs<=maxdata){
+			indices[nobs]   = tempindices[i];
+			dists[nobs]     = h2;
+			nobs++;
+		}
+		if(nobs==1) continue;
+
+		/*Sort all dists up to now*/
+		n=nobs-1;
+		stop = false;
+		for(k=0;k<n-1;k++){
+			if(h2<dists[k]){
+				counter=1;
+				for(int jj=k;jj<n;jj++){
+					j  = n-counter;
+					dists[j+1]   = dists[j];
+					indices[j+1] = indices[j];
+					counter++;
+				}
+				dists[k]   = h2;
+				indices[k] = tempindices[i];
+				stop = true;
+				break;
+			}
+			if(stop) break;
+		}
+	}  
+	xDelete<IssmDouble>(dists);
+	xDelete<int>(tempindices);
+
+	if(nobs){
 		/*Allocate vectors*/
-		x   = (double*)xmalloc(nobs*sizeof(double));
-		y   = (double*)xmalloc(nobs*sizeof(double));
-		obs = (double*)xmalloc(nobs*sizeof(double));
+		x   = xNew<IssmDouble>(nobs);
+		y   = xNew<IssmDouble>(nobs);
+		obs = xNew<IssmDouble>(nobs);
 
 		/*Loop over all observations and fill in x, y and obs*/
@@ -133,5 +241,5 @@
 
 	/*Assign output pointer*/
-	xfree((void**)&indices);
+	xDelete<int>(indices);
 	*px=x;
 	*py=y;
@@ -139,6 +247,182 @@
 	*pnobs=nobs;
 }/*}}}*/
+/*FUNCTION Observations::ObservationList(IssmDouble **px,IssmDouble **py,IssmDouble **pobs,int* pnobs){{{*/
+void Observations::ObservationList(IssmDouble **px,IssmDouble **py,IssmDouble **pobs,int* pnobs){
+
+	/*Output and Intermediaries*/
+	int          nobs;
+	IssmDouble      *x            = NULL;
+	IssmDouble      *y            = NULL;
+	IssmDouble      *obs          = NULL;
+	Observation *observation  = NULL;
+
+	nobs = this->Size();
+
+	if(nobs){
+		x   = xNew<IssmDouble>(nobs);
+		y   = xNew<IssmDouble>(nobs);
+		obs = xNew<IssmDouble>(nobs);
+		for(int i=0;i<this->Size();i++){
+			observation=(Observation*)this->GetObjectByOffset(i);
+			observation->WriteXYObs(&x[i],&y[i],&obs[i]);
+		}
+	}
+
+	/*Assign output pointer*/
+	*px=x;
+	*py=y;
+	*pobs=obs;
+	*pnobs=nobs;
+}/*}}}*/
+/*FUNCTION Observations::InterpolationIDW{{{*/
+void Observations::InterpolationIDW(IssmDouble *pprediction,IssmDouble x_interp,IssmDouble y_interp,IssmDouble radius,int mindata,int maxdata,IssmDouble power){
+
+	/*Intermediaries*/
+	int    i,n_obs;
+	IssmDouble prediction;
+	IssmDouble numerator,denominator,h,weight;
+	IssmDouble *x   = NULL;
+	IssmDouble *y   = NULL;
+	IssmDouble *obs = NULL;
+
+	/*Some checks*/
+	_assert_(maxdata>0);
+	_assert_(pprediction);
+	_assert_(power>0);
+
+	/*If radius is not provided or is 0, return all observations*/
+	if(radius==0) radius=this->quadtree->root->length;
+
+	/*Get list of observations for current point*/
+	this->ObservationList(&x,&y,&obs,&n_obs,x_interp,y_interp,radius,maxdata);
+
+	/*If we have less observations than mindata, return UNDEF*/
+	if(n_obs<mindata){
+		prediction = UNDEF; 
+	}
+	else{
+		numerator   = 0.;
+		denominator = 0.;
+		for(i=0;i<n_obs;i++){
+			h = sqrt( (x[i]-x_interp)*(x[i]-x_interp) + (y[i]-y_interp)*(y[i]-y_interp));
+			if (h<0.0000001){
+				numerator   = obs[i];
+				denominator = 1.;
+				break;
+			}
+			weight = 1./pow(h,power);
+			numerator   += weight*obs[i];
+			denominator += weight;
+		}
+		prediction = numerator/denominator; 
+	}
+
+	/*clean-up*/
+	*pprediction = prediction;
+	xDelete<IssmDouble>(x);
+	xDelete<IssmDouble>(y);
+	xDelete<IssmDouble>(obs);
+}/*}}}*/
+/*FUNCTION Observations::InterpolationKriging{{{*/
+void Observations::InterpolationKriging(IssmDouble *pprediction,IssmDouble *perror,IssmDouble x_interp,IssmDouble y_interp,IssmDouble radius,int mindata,int maxdata,Variogram* variogram){
+
+	/*Intermediaries*/
+	int           i,j,n_obs;
+	IssmDouble        prediction,error;
+	IssmDouble        numerator,denominator,ratio;
+	IssmDouble       *x            = NULL;
+	IssmDouble       *y            = NULL;
+	IssmDouble       *obs          = NULL;
+	IssmDouble       *Gamma        = NULL;
+	IssmDouble       *GinvG0       = NULL;
+	IssmDouble       *Ginv1        = NULL;
+	IssmDouble       *GinvZ        = NULL;
+	IssmDouble       *gamma0       = NULL;
+	IssmDouble       *ones         = NULL;
+
+	/*Some checks*/
+	_assert_(mindata>0 && maxdata>0);
+	_assert_(pprediction && perror);
+
+	/*If radius is not provided or is 0, return all observations*/
+	if(radius==0) radius=this->quadtree->root->length;
+
+	/*Get list of observations for current point*/
+	this->ObservationList(&x,&y,&obs,&n_obs,x_interp,y_interp,radius,maxdata);
+
+	/*If we have less observations than mindata, return UNDEF*/
+	if(n_obs<mindata){
+		*pprediction = -999.0; 
+		*perror      = -999.0; 
+		return;
+	}
+
+	/*Allocate intermediary matrix and vectors*/
+	Gamma  = xNew<IssmDouble>(n_obs*n_obs);
+	gamma0 = xNew<IssmDouble>(n_obs);
+	ones   = xNew<IssmDouble>(n_obs);
+
+	/*First: Create semivariogram matrix for observations*/
+	for(i=0;i<n_obs;i++){
+		for(j=0;j<=i;j++){
+			//Gamma[i*n_obs+j] = variogram->SemiVariogram(x[i]-x[j],y[i]-y[j]);
+			Gamma[i*n_obs+j] = variogram->Covariance(x[i]-x[j],y[i]-y[j]);
+			Gamma[j*n_obs+i] = Gamma[i*n_obs+j];
+		}
+	}
+	for(i=0;i<n_obs;i++) ones[i]=1;
+
+	/*Get semivariogram vector associated to this location*/
+	//for(i=0;i<n_obs;i++) gamma0[i] = variogram->SemiVariogram(x[i]-x_interp,y[i]-y_interp);
+	for(i=0;i<n_obs;i++) gamma0[i] = variogram->Covariance(x[i]-x_interp,y[i]-y_interp);
+
+	/*Solve the three linear systems*/
+#if _HAVE_GSL_
+	SolverxGsl(&GinvG0,Gamma,gamma0,n_obs); // Gamma^-1 gamma0
+	SolverxGsl(&Ginv1, Gamma,ones,n_obs);   // Gamma^-1 ones
+	SolverxGsl(&GinvZ, Gamma,obs,n_obs);    // Gamma^-1 Z
+#else
+	_error2_("GSL is required");
+#endif
+
+	/*Prepare predictor*/
+	numerator=-1.; denominator=0.;
+	for(i=0;i<n_obs;i++) numerator  +=GinvG0[i];
+	for(i=0;i<n_obs;i++) denominator+=Ginv1[i];
+	ratio=numerator/denominator;
+
+	prediction = 0.;
+	error      = - numerator*numerator/denominator;
+	for(i=0;i<n_obs;i++) prediction += (gamma0[i]-ratio)*GinvZ[i];
+	for(i=0;i<n_obs;i++) error += gamma0[i]*GinvG0[i];
+
+	/*clean-up*/
+	*pprediction = prediction;
+	*perror = error;
+	xDelete<IssmDouble>(x);
+	xDelete<IssmDouble>(y);
+	xDelete<IssmDouble>(obs);
+	xDelete<IssmDouble>(Gamma);
+	xDelete<IssmDouble>(gamma0);
+	xDelete<IssmDouble>(ones);
+	xDelete<IssmDouble>(GinvG0);
+	xDelete<IssmDouble>(Ginv1);
+	xDelete<IssmDouble>(GinvZ);
+
+}/*}}}*/
+/*FUNCTION Observations::InterpolationNearestNeighbor{{{*/
+void Observations::InterpolationNearestNeighbor(IssmDouble *pprediction,IssmDouble x_interp,IssmDouble y_interp,IssmDouble radius){
+
+	/*Intermediaries*/
+	IssmDouble        x,y,obs;
+
+	/*Get clostest observation*/
+	this->ClosestObservation(&x,&y,&obs,x_interp,y_interp,radius);
+
+	/*Assign output pointer*/
+	*pprediction = obs;
+}/*}}}*/
 /*FUNCTION Observations::QuadtreeColoring{{{*/
-void Observations::QuadtreeColoring(double* A,double *x,double *y,int n){
+void Observations::QuadtreeColoring(IssmDouble* A,IssmDouble *x,IssmDouble *y,int n){
 
 	int xi,yi,level;
@@ -147,20 +431,19 @@
 		this->quadtree->IntergerCoordinates(&xi,&yi,x[i],y[i]);
 		this->quadtree->QuadtreeDepth(&level,xi,yi);
-		A[i]=(double)level;
+		A[i]=(IssmDouble)level;
 	}
 
 }/*}}}*/
 /*FUNCTION Observations::Variomap{{{*/
-void Observations::Variomap(double* gamma,double *x,int n){
+void Observations::Variomap(IssmDouble* gamma,IssmDouble *x,int n){
 
 	/*Output and Intermediaries*/
-	int          nobs,i,j,k;
-	double       range;
+	int          i,j,k;
+	IssmDouble       distance;
 	Observation *observation1 = NULL;
 	Observation *observation2 = NULL;
-	int         *indices      = NULL;
-
-	int *counter= (int*)xmalloc(n*sizeof(int));
-	for(j=0;j<n;j++) counter[j] = 0;
+
+	IssmDouble *counter = xNew<IssmDouble>(n);
+	for(j=0;j<n;j++) counter[j] = 0.0;
 	for(j=0;j<n;j++) gamma[j]   = 0.0;
 
@@ -168,26 +451,26 @@
 		observation1=(Observation*)this->GetObjectByOffset(i);
 
-		for(j=0;j<n;j++){
-			range=x[j]; _assert_(range>=0.);
-
-			/*Find all observations that are in range*/
-			this->quadtree->RangeSearch(&indices,&nobs,observation1->x,observation1->y,range);
-
-			for (k=0;k<nobs;k++){
-				observation2 = (Observation*)this->GetObjectByOffset(indices[k]);
-				gamma[j]    += 1./2.*pow(observation1->value - observation2->value,2.);
-			}
-
-			counter[j] += nobs;
-			xfree((void**)&indices);
+		for(j=i+1;j<this->Size();j++){
+			observation2=(Observation*)this->GetObjectByOffset(j);
+
+			distance=sqrt(pow(observation1->x - observation2->x,2.) + pow(observation1->y - observation2->y,2.));
+			if(distance>x[n-1]) continue;
+
+			int index = int(distance/(x[1]-x[0]));
+			if(index>n-1) index = n-1;
+			if(index<0)   index = 0;
+
+			gamma[index]   += 1./2.*pow(observation1->value - observation2->value,2.);
+			counter[index] += 1.;
 		}
 	}
 
 	/*Normalize semivariogram*/
-	for(j=0;j<n;j++){
-		if(counter[j]) gamma[j] = gamma[j]/double(counter[j]);
+	gamma[0]=0.;
+	for(k=0;k<n;k++){
+		if(counter[k]) gamma[k] = gamma[k]/counter[k];
 	}
 
 	/*Assign output pointer*/
-	xfree((void**)&counter);
-}/*}}}*/
+	xDelete<IssmDouble>(counter);
+}/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/Container/Observations.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Observations.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Observations.h	(revision 12878)
@@ -6,6 +6,8 @@
 #define  _CONTAINER_OBSERVATIONS_H_
 
-class Obsevration;
+#include "../include/include.h"
+
 class Quadtree;
+class Variogram;
 class Options;
 
@@ -19,11 +21,16 @@
 		/*constructors, destructors*/
 		Observations();
-		Observations(double* observations_list,double* x,double* y,int n,Options* options);
+		Observations(IssmDouble* observations_list,IssmDouble* x,IssmDouble* y,int n,Options* options);
 		~Observations();
 
 		/*Methods*/
-		void ObservationList(double **px,double **py,double **pobs,int* pnobs,double x_interp,double y_interp,double range);
-		void QuadtreeColoring(double* A,double *x,double *y,int n);
-		void Variomap(double* gamma,double *x,int n);
+		void ClosestObservation(IssmDouble *px,IssmDouble *py,IssmDouble *pobs,IssmDouble x_interp,IssmDouble y_interp,IssmDouble radius);
+		void InterpolationIDW(IssmDouble *pprediction,IssmDouble x_interp,IssmDouble y_interp,IssmDouble radius,int mindata,int maxdata,IssmDouble power);
+		void InterpolationKriging(IssmDouble *pprediction,IssmDouble *perror,IssmDouble x_interp,IssmDouble y_interp,IssmDouble radius,int mindata,int maxdata,Variogram* variogram);
+		void InterpolationNearestNeighbor(IssmDouble *pprediction,IssmDouble x_interp,IssmDouble y_interp,IssmDouble radius);
+		void ObservationList(IssmDouble **px,IssmDouble **py,IssmDouble **pobs,int* pnobs);
+		void ObservationList(IssmDouble **px,IssmDouble **py,IssmDouble **pobs,int* pnobs,IssmDouble x_interp,IssmDouble y_interp,IssmDouble radius,int maxdata);
+		void QuadtreeColoring(IssmDouble* A,IssmDouble *x,IssmDouble *y,int n);
+		void Variomap(IssmDouble* gamma,IssmDouble *x,int n);
 
 };
Index: issm/branches/trunk-jpl-damage/src/c/Container/Options.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Options.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Options.cpp	(revision 12878)
@@ -4,5 +4,5 @@
  */
 
-/*Headers: {{{1*/
+/*Headers: {{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -13,4 +13,5 @@
 #include <vector>
 #include <algorithm>
+#include <cstring>
 
 #include "./DataSet.h"
@@ -24,10 +25,10 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Options::Options(){{{1*/
+/*FUNCTION Options::Options(){{{*/
 Options::Options(){
 	return;
 }
 /*}}}*/
-/*FUNCTION Options::~Options(){{{1*/
+/*FUNCTION Options::~Options(){{{*/
 Options::~Options(){
 	return;
@@ -36,5 +37,5 @@
 
 /*Object management*/
-/*FUNCTION Options::AddOption{{{1*/
+/*FUNCTION Options::AddOption{{{*/
 int  Options::AddOption(Option* in_option){
 
@@ -46,8 +47,8 @@
 
 	/*Also, check the option name*/
-	if(!in_option->name) _error_("input option has an empty name");
-	if(strchr(in_option->name,'.')) _error_("Option \"%s\" has a protected character \".\"",in_option->name);
-	if(strchr(in_option->name,'[')) _error_("Option \"%s\" has a protected character \"[\"",in_option->name);
-	if(strchr(in_option->name,']')) _error_("Option \"%s\" has a protected character \"]\"",in_option->name);
+	if(!in_option->name) _error2_("input option has an empty name");
+	if(strchr(in_option->name,'.')) _error2_("Option \"" << in_option->name << "\" has a protected character \".\"");
+	if(strchr(in_option->name,'[')) _error2_("Option \"" << in_option->name << "\" has a protected character \"[\"");
+	if(strchr(in_option->name,']')) _error2_("Option \"" << in_option->name << "\" has a protected character \"]\"");
 
 	/*Finally, check that no option of the same name already exists in the dataset*/
@@ -56,5 +57,5 @@
 		option=(Option*)(*object); 
 		if (!strcmp(option->name,in_option->name)){
-			_error_("Options \"%s\" found multiple times",in_option->name);
+			_error2_("Options \"" << in_option->name << "\" found multiple times");
 			break;
 		}
@@ -67,25 +68,25 @@
 }
 /*}}}*/
-/*FUNCTION Options::Get(double* pvalue, char* name){{{1*/
-void Options::Get(double* pvalue,const char* name){
-
-	vector<Object*>::iterator object;
-	Option* option=NULL;
-
-	/*Get option*/
-	option=GetOption(name);
-
-	/*If the pointer is not NULL, the option has been found*/
-	if(option){
-		option->Get(pvalue);
-	}
-	/*Else, the Option does not exist, no default provided*/
-	else{
-		_error_("option of name \"%s\" not found, and no default value has been provided",name);
-	}
-}
-/*}}}*/
-/*FUNCTION Options::Get(double* pvalue, char* name,double default_value){{{1*/
-void Options::Get(double* pvalue,const char* name,double default_value){
+/*FUNCTION Options::Get(int* pvalue, char* name){{{*/
+void Options::Get(int* pvalue,const char* name){
+
+	vector<Object*>::iterator object;
+	Option* option=NULL;
+
+	/*Get option*/
+	option=GetOption(name);
+
+	/*If the pointer is not NULL, the option has been found*/
+	if(option){
+		option->Get(pvalue);
+	}
+	/*Else, the Option does not exist, no default provided*/
+	else{
+		_error2_("option of name \"" << name << "\" not found, and no default value has been provided");
+	}
+}
+/*}}}*/
+/*FUNCTION Options::Get(int* pvalue, char* name,int default_value){{{*/
+void Options::Get(int* pvalue,const char* name,int default_value){
 
 	vector<Object*>::iterator object;
@@ -105,5 +106,43 @@
 }
 /*}}}*/
-/*FUNCTION Options::Get(bool* pvalue, char* name){{{1*/
+/*FUNCTION Options::Get(IssmDouble* pvalue, char* name){{{*/
+void Options::Get(IssmDouble* pvalue,const char* name){
+
+	vector<Object*>::iterator object;
+	Option* option=NULL;
+
+	/*Get option*/
+	option=GetOption(name);
+
+	/*If the pointer is not NULL, the option has been found*/
+	if(option){
+		option->Get(pvalue);
+	}
+	/*Else, the Option does not exist, no default provided*/
+	else{
+		_error2_("option of name \"" << name << "\" not found, and no default value has been provided");
+	}
+}
+/*}}}*/
+/*FUNCTION Options::Get(IssmDouble* pvalue, char* name,IssmDouble default_value){{{*/
+void Options::Get(IssmDouble* pvalue,const char* name,IssmDouble default_value){
+
+	vector<Object*>::iterator object;
+	Option* option=NULL;
+
+	/*Get option*/
+	option=GetOption(name);
+
+	/*If the pointer is not NULL, the option has been found*/
+	if(option){
+		option->Get(pvalue);
+	}
+	/*Else, the Option does not exist, a default is provided here*/
+	else{
+		*pvalue=default_value;
+	}
+}
+/*}}}*/
+/*FUNCTION Options::Get(bool* pvalue, char* name){{{*/
 void Options::Get(bool* pvalue,const char* name){
 
@@ -120,9 +159,9 @@
 	/*Else, the Option does not exist, no default provided*/
 	else{
-		_error_("option of name \"%s\" not found, and no default value has been provided",name);
-	}
-}
-/*}}}*/
-/*FUNCTION Options::Get(bool* pvalue, char* name,bool default_value){{{1*/
+		_error2_("option of name \"" << name << "\" not found, and no default value has been provided");
+	}
+}
+/*}}}*/
+/*FUNCTION Options::Get(bool* pvalue, char* name,bool default_value){{{*/
 void Options::Get(bool* pvalue,const char* name,bool default_value){
 
@@ -143,5 +182,5 @@
 }
 /*}}}*/
-/*FUNCTION Options::Get(char** pvalue, char* name){{{1*/
+/*FUNCTION Options::Get(char** pvalue, char* name){{{*/
 void Options::Get(char** pvalue,const char* name){
 
@@ -160,10 +199,10 @@
 	/*Else, the Option does not exist, no default provided*/
 	else{
-		_error_("option of name \"%s\" not found, and no default value has been provided",name);
-	}
-
-}
-/*}}}*/
-/*FUNCTION Options::Get(char** pvalue, char* name,char* default_value){{{1*/
+		_error2_("option of name \"" << name << "\" not found, and no default value has been provided");
+	}
+
+}
+/*}}}*/
+/*FUNCTION Options::Get(char** pvalue, char* name,char* default_value){{{*/
 void Options::Get(char** pvalue,const char* name,const char* default_value){
 
@@ -183,6 +222,6 @@
 	else{
 		stringsize=strlen(default_value)+1;
-		outstring=(char*)xmalloc(stringsize*sizeof(char));
-		memcpy(outstring,default_value,stringsize*sizeof(char));
+		outstring=xNew<char>(stringsize);
+		xMemCpy<char>(outstring,default_value,stringsize);
 		*pvalue=outstring;
 	}
@@ -190,5 +229,5 @@
 }
 /*}}}*/
-/*FUNCTION Options::Get(char*** ppvalue,int* numel,char* name){{{1*/
+/*FUNCTION Options::Get(char*** ppvalue,int* numel,char* name){{{*/
 void Options::Get(char*** ppvalue,int* numel,const char* name){
 
@@ -207,5 +246,5 @@
 		if(option->ObjectEnum()==OptionCellEnum){
 			if (option->NumEl()) {
-				*ppvalue=(char **) xmalloc(option->NumEl()*sizeof(char *));
+				*ppvalue=xNew<char*>(option->NumEl());
 				if (numel) *numel=option->NumEl();
 				option->Get(&options);
@@ -225,5 +264,5 @@
 		/*Else: not supported*/
 		else{
-			_error_("Cannot recover field \"%s\" for an option of type %s",name,EnumToStringx(option->ObjectEnum()));
+			_error2_("Cannot recover field \"" << name << "\" for an option of type " << EnumToStringx(option->ObjectEnum()));
 		}
 	}
@@ -236,6 +275,6 @@
 }
 /*}}}*/
-/*FUNCTION Options::Get(double** pvalue,int* numel,const char* name){{{1*/
-void Options::Get(double** pvalue,int* numel,const char* name){
+/*FUNCTION Options::Get(IssmDouble** pvalue,int* numel,const char* name){{{*/
+void Options::Get(IssmDouble** pvalue,int* numel,const char* name){
 
 	vector<Object*>::iterator object;
@@ -251,9 +290,9 @@
 	/*Else, the Option does not exist, no default provided*/
 	else{
-		_error_("option of name \"%s\" not found, and no default value has been provided",name);
-	}
-}
-/*}}}*/
-/*FUNCTION Options::GetOption{{{1*/
+		_error2_("option of name \"" << name << "\" not found, and no default value has been provided");
+	}
+}
+/*}}}*/
+/*FUNCTION Options::GetOption{{{*/
 Option* Options::GetOption(const char* name){
 
@@ -285,5 +324,5 @@
 				/*Else: not supported*/
 				else{
-					_error_("Cannot recover field \"%s\" for an option of type %s",name,EnumToStringx(option->ObjectEnum()));
+					_error2_("Cannot recover field \"" << name << "\" for an option of type " << EnumToStringx(option->ObjectEnum()));
 				}
 			}
Index: issm/branches/trunk-jpl-damage/src/c/Container/Options.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Options.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Options.h	(revision 12878)
@@ -20,6 +20,8 @@
 		int  AddOption(Option* in_oobject);
 		Option* GetOption(const char* name);
-		void Get(double*  pvalue,const char* name);
-		void Get(double*  pvalue,const char* name,double default_value);
+		void Get(IssmDouble*  pvalue,const char* name);
+		void Get(IssmDouble*  pvalue,const char* name,IssmDouble default_value);
+		void Get(int*  pvalue,const char* name);
+		void Get(int*  pvalue,const char* name,int default_value);
 		void Get(bool*    pvalue,const char* name);
 		void Get(bool*    pvalue,const char* name,bool default_value);
@@ -27,5 +29,5 @@
 		void Get(char**   pvalue,const char* name,const char* default_value);
 		void Get(char***  pvalue,int* numel,const char* name);
-		void Get(double** pvalue,int* numel,const char* name);
+		void Get(IssmDouble** pvalue,int* numel,const char* name);
 };
 
